import java.applet.Applet;
import java.applet.AppletStub;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Window;
import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Method;
import java.lang.reflect.Proxy;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Properties;

import javax.swing.JFrame;
import javax.swing.JPanel;

public class Loader extends Applet implements AppletStub {

	private static final long serialVersionUID = 1L;

	public static final int CLIENT_REVISON = 728;
	public static final int SUB_REVISION =  1;

	public static final String IP_ADDRESS = "127.0.0.1";

	public static final int LOBBY_PORT = 43594;
	public static final int DEVELOPMENT_GAME_PORT = 43594;

	public static final boolean LOBBY_ENABLED = false;
	public static final boolean USING_ISAAC = false;
	public static final boolean DISABLE_XTEA_CRASH = true;
	public static final boolean DISABLE_USELESS_PACKETS = true;
	public static final boolean DISABLE_RSA = false;

	public static Properties clientParams = new Properties();

	public JFrame clientFrame = null;

	public static void main(String[] arg0) {
		new Loader().doFrame();
	}

	@Override
	public void init() {
		doApplet();
	}

	private void doApplet() {
		setParms();
		startClient();
	}

	private void doFrame() {
		setParms();
		openFrame();
		startClient();
		clientFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}

	private void setParms() {
		clientParams.put("java_arguments" ,"-Xmx256m -Xss2m -Dsun.java2d.noddraw=true -XX:CompileThreshold=1500 -Xincgc -XX:+UseConcMarkSweepGC -XX:+UseParNewGC");
		clientParams.put("boxbgcolor" ,"black");
		clientParams.put("centerimage" ,"true");
		clientParams.put("image" ,"https://www.runescape.com/img/game/splash2.gif");
		clientParams.put("boxborder" ,"false");
		clientParams.put("separate_jvm" ,"true");
		clientParams.put("18" ,"0");
		clientParams.put("12" ,"nojD/tASnSznLQ0QNG89qhqqNGDRblMm");
		clientParams.put("3" ,"0");
		clientParams.put("11" ,"FB6C3840F9053E50E480D006AC2A1163CC895097F164B05CB0C629EEE05F978D815C80A2193B6212753D6ACB8E0DD1B3");
		clientParams.put("2" ,"false");
		clientParams.put("25" ,"");
		clientParams.put("31" ,"true");
		clientParams.put("5" ,"false");
		clientParams.put("16" ,"81");
		clientParams.put("29" ,"");
		clientParams.put("32" ,"false");
		clientParams.put("14" ,"DBXPZaBPotHnzeZldoHBTxXnbnMFe3VcAAAAAAA");
		clientParams.put("22" ,"0");
		clientParams.put("30" ,"0");
		clientParams.put("7" ,"lobby18.runescape.com");
		clientParams.put("8" ,"true");
		clientParams.put("23" ,"true,false,0,43,200,18,0,21,354,-15,Verdana,11,0xF4ECE9,candy_bar_middle.gif,candy_bar_back.gif,candy_bar_outline_left.gif,candy_bar_outline_right.gif,candy_bar_outline_top.gif,candy_bar_outline_bottom.gif,loadbar_body_left.gif,loadbar_body_right.gif,loadbar_body_fill.gif,6");
		clientParams.put("34" ,"false");
		clientParams.put("0" ,"u1d8N7D4ZcLXG5ZlHzVkcA");
		clientParams.put("13" ,"false");
		clientParams.put("20" ,"10634");
		clientParams.put("9" ,"1117");
		clientParams.put("21" ,"1454135939");
		clientParams.put("26" ,"77");
		clientParams.put("-1" ,"gVW4GQknq55gcr-bnW5pGA");
		clientParams.put("24" ,"false");
		clientParams.put("6" ,"");
		clientParams.put("35" ,"0");
		clientParams.put("15" ,"");
		clientParams.put("28" ,".runescape.com");
		clientParams.put("27" ,"0");
		clientParams.put("33" ,"J91bzmtwA-uSfGVu5*BoizAwInl7CvhnAH1TLmmp-mo");
		clientParams.put("4" ,"2366854382357407428");
	}

	private void openFrame() {
		clientFrame = new JFrame("Matrix - The most advanced RSPS!");
		final String OS = System.getProperty("os.name");
		if(OS.contains("Mac") || OS.contains("OS X")) {
			final double version = Double.parseDouble(System.getProperty("os.version"));
			if(version >= 10.7) {
				enableOSXFullscreen(clientFrame);
			}
		}
		clientFrame.setLayout(new BorderLayout());
		final JPanel client_panel = new JPanel();
		client_panel.setLayout(new BorderLayout());
		client_panel.add(this);
		client_panel.setPreferredSize(new Dimension(800, 600));
		clientFrame.getContentPane().add(client_panel, "Center");
		clientFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		clientFrame.pack();
		clientFrame.setVisible(true);
	}

	private void startClient() {
		try {
			client clnt = new client();
			clnt.supplyApplet(this);
			clnt.init();
			clnt.start();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	@SuppressWarnings({ "unchecked", "rawtypes" })
	public static void enableOSXFullscreen(final Window window) {
		try {
			final Class util = Class.forName("com.apple.eawt.FullScreenUtilities");
			final Method method = util.getMethod("setWindowCanFullScreen", new Class[]{ Window.class, Boolean.TYPE });
			method.invoke(util, window, true);
			final Class listener = Class.forName("com.apple.eawt.FullScreenListener");
			util.getMethod("addFullScreenListenerTo", new Class[]{ Window.class, listener }).invoke(util, window, Proxy.newProxyInstance(listener.getClassLoader(), new Class[] { listener }, new InvocationHandler() {
				@Override
				public Object invoke(Object proxy, Method method, Object[] args) throws Throwable {
					if(method.getName() == "windowEnteredFullScreen") {
						window.repaint();
						System.out.println("Entered fullscreen: "+window.getWidth()+" - "+window.getHeight());
					}
					return null;
				}
			}));
		} catch (Throwable t) {
			t.printStackTrace();
		}
	}

	@Override
	public String getParameter(String arg0) {
		return (String) clientParams.get(arg0);
	}

	@Override
	public void appletResize(int arg0, int arg1) {

	}

	@Override
	public URL getDocumentBase() {
		try {
			return new URL("http://" + IP_ADDRESS);
		} catch (MalformedURLException e) {
			System.out.println("Invalid ip address");
		}
		return null;
	}

	@Override
	public URL getCodeBase() {
		try {
			return new URL("http://" + IP_ADDRESS);
		} catch (MalformedURLException e) {
			System.out.println("Invalid ip address");
		}
		return null;
	}

}